//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include "shiori_dll.h"
#include "nasino.h"

extern char LogTmp[AnswerLength];
extern int DicWordCount;						/* ̑vf */
extern ghost_data ghost_profile;								// GhostɊւf[^

//int GhostTalkInterval = 30;
int GhostTalkCounter = 0;
extern int ScriptSwitch;						/* XNvgsXCb` */


//---------------------------------------------------------------------------
//		 SHIORI/2.2 Event
//
//		answerdata->sentence		OUT		쐬ԓ
//		answerdata->targetHWnd		OUT		ԓHWndBw肵Ȃꍇ""
//		answerdata->version			OUT		vgRo[W
//		answerdata->code			OUT		ԓpR[h
//		s20_data commdata		IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret					OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s22event(struct s20_data *answerdata,struct s20_data *commdata)
{

	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int *dic_table_p;
	int dic_tablepoint;						// ɍṽe[u
	
	int from_check;
	int to_check;
	int event_check;
	int sentence_check;
	int count0;
	int count1;
	int mode;
	int ret;

	char word[WordLength];
	char* point;
	char logic[DicBufferLength];
	char *answer_tmp;

	logwrite("--- nasino_s22event\n");
//	printf("--- nasino_s22event %s ---\n",commdata.event);
	if(strcmp(commdata->event,"OnSecondChange") == 0){
		if((ScriptSwitch == OFF) && (GhostTalkCounter > ghost_profile.ghosttalkinterval)){						// Iɔb bIɂɓBƏ㗬GET Sentence𔭍sׂB
			logwrite("Ib\n");
			get_tagword(commdata->buffer,"sentence");
			make_sentence2(answerdata,commdata,0);
			if(answerdata->version != 23){
				answerdata->version = 22;
				answerdata->code = 200;
			}
//			sprintf(LogTmp,"GhostTalk:%s:\n",answerdata->sentence);
//			logwrite(LogTmp);
			GhostTalkCounter = 0;
			return(OK);
		}else if(ghost_profile.ghosttalkinterval != 0){								// 0 ݒ͔bB
//			sprintf(LogTmp,"GhostTalkCounter:%d:\n",GhostTalkCounter);
//			logwrite(LogTmp);
			GhostTalkCounter++;
		}
	}else if(strcmp(commdata->event,"SE.SentenceTalk") == 0){			// SystemEvent : Ib
		logwrite("Ib SE.SentenceTalk\n");
		logwrite("Ib\n");
		get_tagword(commdata->buffer,"sentence");
		
		sprintf(LogTmp,"commdata->buffer:%s\n",commdata->buffer);
		logwrite(LogTmp);
		
		make_sentence2(answerdata,commdata,0);
		
		if(answerdata->version != 23){
			answerdata->version = 22;
			answerdata->code = 200;
		}
		sprintf(LogTmp,"answerdata->version:%d\n",answerdata->version);
		logwrite(LogTmp);
		sprintf(LogTmp,"answerdata->code:%d\n",answerdata->code);
		logwrite(LogTmp);
		
		printf("--- SE.SentenceTalk end ---\n");
		return(OK);
		
	}else if(strcmp(commdata->event,"SE.GhostCommunicate") == 0){		// SystemEvent : Ghostɘb
		printf("UserEvent SE.GhostCommunicate\n");
		logwrite("UserEvent SE.GhostCommunicate\n");
		strcpy(commdata->reference0,commdata->reference0);
		strcpy(commdata->reference1,commdata->reference1);
		strcpy(commdata->reference2,commdata->reference2);
		strcpy(commdata->reference3,commdata->reference3);
		strcpy(commdata->reference4,commdata->reference4);
		strcpy(commdata->reference5,commdata->reference5);
		strcpy(commdata->reference6,commdata->reference6);
		strcpy(commdata->reference7,commdata->reference7);
		if(nasino_getghostname(answerdata->to,commdata) == OK){
			printf("answerdata->to:%s:%s\n",answerdata->to,commdata->to);
			sprintf(LogTmp,"answerdata->to:%s:%s\n",answerdata->to,commdata->to);
			logwrite(LogTmp);
			mode = nasino_s23ghostcomminucate(answerdata,commdata);										//
			//Header
			answerdata->code = 200;
			answerdata->version = 23;
			// Sender:
			strcpy(answerdata->sender,ghost_profile.sakuraname);
			// Age:
			answerdata->age = 0;
			
			if(mode == OK){
				sprintf(LogTmp,"nasino_s23communicate:%s:\n",answerdata->sentence);
				logwrite(LogTmp);
			}else{										// ėp̃Zt
				// Sentence:
				strcpy(answerdata->sentence,"\\hف[\\n\\w8CɓVn􂵂Ă邩H\\n\\e");
			}
			ret = OK;
		}else{
			// ̃S[Xg͂ȂB
			logwrite("S[XgȂ\n");
			answerdata->version = 22;
			answerdata->code = 200;
			strcpy(answerdata->sentence,ST_NoOtherGhost);
			strcpy(commdata->buffer,ST_NoOtherGhost);
			make_sentence2(answerdata,commdata,0);
			ret = NG;
		}
		printf("--- nasino_s22event end ---\n");
		return(OK);
	}else if((strcmp(commdata->event,"SE.NoSearchDic") == 0)||(strcmp(commdata->event,"NoSearchDic") == 0)){				// NoSearchDic ̏ꍇ NG ƂBX}[gȏȂȂB
		answerdata->version = 22;
		answerdata->code = 204;
		return(NG);
	}
	
//	logwrite("S22_1\n");
	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		logwrite("S22_malloc_error!\n");
		// malloc error.
	}else{
//		logwrite("S22_2\n");
		word_count = nasino_eventmachcount(tag_table,*commdata,0);					// event ܂ 
		printf("S22 EVENT word_count:%d\n",word_count);
		sprintf(LogTmp,"S22 EVENT word_count:%d\n",word_count);
		logwrite(LogTmp);

		if(word_count > 0){
			if(word_count > 0){
				get_dicword(&dicreaddata,tag_table[nasino_random(word_count)]);
//				printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
				ret = OK;
//				logwrite("OK\n");
			}else{
				ret = NG;
//				logwrite("NG\n");
			}
		}
		free(tag_table);
	}
	
	if(ret == OK){
//		strcpy(answerdata->sentence,dicreaddata.word);
//		printf("answerdata->sentence:%s\n",answerdata->sentence);
		
//		make_sentence(answerdata->sentence,dicreaddata.word,0);
		strcpy(commdata->buffer,dicreaddata.word);
		make_sentence2(answerdata,commdata,0);
//		printf("answerdata->sentence:%s\n",answerdata->sentence);
//		sprintf(LogTmp,"1: nasino_s21communicate:%s:\n",answerdata->sentence);
//		logwrite(LogTmp);
		if(answerdata->version != 23){
			answerdata->version = 22;
			answerdata->code = 200;
		}
	}else{
		answerdata->version = 22;
		answerdata->code = 204;
	}

	return(ret);
}


//---------------------------------------------------------------------------
//		 SHIORI/2.2 Event
//
//		*answer				OUT		쐬
//		*buffer				IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret				OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s22event_old(char *answer,struct s20_data commdata)
{
	dic_readdata dicreaddata;
	char nasino_tag[DicBufferLength];
	char reference_tag[DicBufferLength];
	char tagtmp[DicBufferLength];
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;
	char *reference_pointer[ReferenceNum];
	char *point;
	char *point2;
	char logic[DicBufferLength];
	
	int ret;
	int count0,count1;
	int flug;
	
	printf("nasino_s22event\n");
	
	reference_pointer[0] = commdata.reference0;
	reference_pointer[1] = commdata.reference1;
	reference_pointer[2] = commdata.reference2;
	reference_pointer[3] = commdata.reference3;
	reference_pointer[4] = commdata.reference4;
	reference_pointer[5] = commdata.reference5;
	reference_pointer[6] = commdata.reference6;
	reference_pointer[7] = commdata.reference7;
	
	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
	
		sprintf(nasino_tag,"%s event %s",NASINO_TAG,commdata.event);			// BėpɌB
		word_count = tagwordcount(nasino_tag,tag_table);
		if(word_count > 0){
			if((dic_table = (int*)malloc(word_count))==NULL){
				// malloc error.
			}else{
				dic_tablepoint = 0;
				for(count0=0;tag_table[count0]<DicWordCount;count0++){
					get_dicword(&dicreaddata,tag_table[count0]);
					flug = ON;
					for(count1=0;count1<ReferenceNum;count1++){
						sprintf(reference_tag,"reference%d",count1);
						printf("referencetag:%s:\n",reference_tag);
						point = strstr(dicreaddata.key,reference_tag);
						printf("1:%s:%d:%d\n",dicreaddata.key,count0,count1);
						if(point != NULL){
							point += strlen(reference_tag) + 1;
							printf("reference%d:%s:\n",count1,point);
						
							strcpy(tagtmp,point);
							point2 = strstr(tagtmp,"]");
							if(point2 != NULL){			// []^Om
								*point2 = '\0';
//								tagtmp[strlen(tagtmp)-1] = '\0';
								sprintf(LogTmp,"tagtmp:%s:\n",tagtmp);
								logwrite(LogTmp);
								strcpy(logic,"");
								logic_make(logic,tagtmp,reference_pointer[count1],LOGIC_STRSTR);
								printf("calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
								sprintf(LogTmp,"calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
								logwrite(LogTmp);
								if(logic_calc(logic) == 1){
//									dic_table[dic_tablepoint] = tag_table[count1];
//									dic_tablepoint++;
								}else{
									flug = OFF;
								}
							}
							
						}
					}
					if(flug== ON){
						dic_table[dic_tablepoint] = tag_table[count0];
						dic_tablepoint++;
					}
				}
				printf("dic_tablepoint:%d\n",dic_tablepoint);
				for(count0=0;count0<dic_tablepoint;count0++){
					printf("dic_table:%d\n",dic_table[count0]);
				}
				
//				sprintf(LogTmp,"dic_tablepoint:%d,%d:\n",word_count,dic_tablepoint);
//				logwrite(LogTmp);
				printf("2\n");
				if(dic_tablepoint > 0){
					get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
//					make_sentence(answer,dicreaddata.word,0);
					printf("answer:%s\n",answer);
//					sprintf(LogTmp,"answer:%s:\n",answer);
//					logwrite(LogTmp);
					ret = OK;
				}else{
					strcpy(answer,"\\uB\\n\\e");
					sprintf(LogTmp,"answer:%s:\n",answer);
					logwrite(LogTmp);
					ret = NG;
				}
						
//				free(dic_table);
			}
			free(dic_table);
		}else{
//			sprintf(answer,"\\hnasino_tag:%s:\\nword_count:%d:\\n",nasino_tag,word_count);	// TEST code
			ret = NG;
		}
	
	}
	free(tag_table);
	if(ret == OK){
		make_sentence(answer,dicreaddata.word,0);
		printf("answer:%s\n",answer);
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		 SHIORI/2.0 GET Sentence
//
//		*answer					OUT		쐬
//		s20_data commdata		IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret					OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s20get_sentence(struct s20_data *answerdata,struct s20_data commdata)
{
//	char answer[AnswerLength]
	
	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;						// ɍṽe[u
	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
	int sakura_objpoint = 0;							//
	
	int sentence_check;
	int to_check;
	int count0;
	int ret;
	int mode;

//	char word[WordLength];
//	char targetHWnd[WordLength];
//	char* point;
//	char logic[DicBufferLength];


	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
	
		word_count = nasino_tagwordcount(SENTENCE_TAG,tag_table,1);					// from ܂܂Ȃ
		if(word_count > 0){
			if((dic_table = (int*)malloc(word_count))==NULL){
				// malloc error.
			}else{
//				check_sakurafillemappingdata(sakura_object,&sakura_objpoint);
				
				dic_tablepoint = 0;
				for(count0=0;tag_table[count0]<DicWordCount;count0++){
					get_dicword(&dicreaddata,tag_table[count0]);
					printf("dic:%s:%s\n",dicreaddata.key,dicreaddata.word);
					sprintf(LogTmp,"dic:%s:\n",dicreaddata.key);
					logwrite(LogTmp);

					// sentence ̒
					sentence_check = s20diccheck_sentence(dicreaddata,&commdata);
					
					// to ̒
//					to_check = s20diccheck_to(dicreaddata,sakura_object,sakura_objpoint);
					to_check = 0;
					// ʓo^
					if((sentence_check == 1) && (to_check == 1)){
						dic_table[dic_tablepoint] = tag_table[count0];
						dic_tablepoint++;
					}
					printf("dic_tablepoint:%d\n",dic_tablepoint);
					
				}

				if(dic_tablepoint > 0){
					get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);			// 
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
					logwrite("+++SENTENCE+++\n");
					
					make_sentence(answerdata->sentence,dicreaddata.word,0);
					printf("%s\n",answerdata->sentence);
					sprintf(LogTmp,"nasino_s20get_sentence:%s:\n",answerdata->sentence);
					logwrite(LogTmp);
					
					mode = s21gettargetghost(answerdata->targetHWnd,dicreaddata,sakura_object,sakura_objpoint);
					sprintf(LogTmp,"answerdata->targetHWnd:%s:\n",answerdata->targetHWnd);
					logwrite(LogTmp);
					if(mode == OK){										// to BSHIORI/2.1 310 Communicate
						answerdata->version = 21;
						answerdata->code = 310;
					}else{												// SHIORI/2.0 200 OK
						answerdata->version = 20;
						answerdata->code = 200;
					}
					ret = OK;
				}else{
					ret = NG;
				}
				free(dic_table);
			}
		}

		free(tag_table);
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		 SHIORI/2.1 Communicate
//
//		answerdata->sentence		OUT		쐬ԓ
//		answerdata->targetHWnd		OUT		ԓHWndBw肵Ȃꍇ""
//		answerdata->version			OUT		vgRo[W
//		answerdata->code			OUT		ԓpR[h
//		s20_data commdata		IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret					OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s21communicate(struct s20_data *answerdata,struct s20_data commdata)
{

	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;						// ɍṽe[u
	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
	int sakura_objpoint = 0;							//
	
	int from_check;
	int to_check;
	int sentence_check;
	int count0;
	int mode;
	int ret;

	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	logwrite("--- nasino_s21communicate\n");

	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
	
		word_count = nasino_tagwordcount(FROM_TAG,tag_table,0);					// from ܂ 
//		word_count = nasino_tagwordcount(NASINO_TAG,tag_table,0);					// from ܂ 

		if(word_count > 0){
			if((dic_table = (int*)malloc(word_count))==NULL){
				// malloc error.
			}else{
//				check_sakurafillemappingdata(sakura_object,&sakura_objpoint);
				dic_tablepoint = 0;
				for(count0=0;tag_table[count0]<DicWordCount;count0++){
					get_dicword(&dicreaddata,tag_table[count0]);
					printf("dic:%s:%s\n",dicreaddata.key,dicreaddata.word);

					// from ̒
					from_check = s20diccheck_from(dicreaddata,&commdata);
					// to ̒
//					to_check = s20diccheck_to(dicreaddata,sakura_object,sakura_objpoint);			// ̒iKŁAb|鑊肪݂邩̌_͏oĂB
					// sentence ̒
					sentence_check = s20diccheck_sentence(dicreaddata,&commdata);
					// ʓo^
					if((from_check == 1) && (to_check == 1) && (sentence_check == 1)){
						dic_table[dic_tablepoint] = tag_table[count0];
						dic_tablepoint++;
						sprintf(LogTmp,"dicreaddata:%s:%s:\n",dicreaddata.key,dicreaddata.word);
						logwrite(LogTmp);
					}
					printf("dic_tablepoint:%d\n",dic_tablepoint);
					
				}

				if(dic_tablepoint > 0){
					get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
					make_sentence(answerdata->sentence,dicreaddata.word,0);
					printf("%s\n",answerdata->sentence);
					sprintf(LogTmp,"2: nasino_s21communicate:%s:\n",answerdata->sentence);
					logwrite(LogTmp);
					
					mode = s21gettargetghost(answerdata->targetHWnd,dicreaddata,sakura_object,sakura_objpoint);
					sprintf(LogTmp,"answerdata->targetHWnd:%s:\n",answerdata->targetHWnd);
					logwrite(LogTmp);
//					if(mode == OK){										// to BSHIORI/2.1 310 Communicate
						answerdata->version = 21;
						answerdata->code = 310;
//					}else{												// SHIORI/2.0 200 OK
//						answerdata->version = 20;
//						answerdata->code = 200;
//					}
					ret = OK;
				}else{
					ret = NG;
				}
				free(dic_table);
			}
		}

		free(tag_table);
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		 SHIORI/2.3 Get Ghost Name
//
//		char *ghostname							OUT	Ghost̖Õ|C^
//		struct s20_data commdata->ghost_name	IN	vGhost̖O
//		int ret									OUT	OK:쐬 NG:쐬ł
//
//	bGhost̖O𓾂B
//	vꂽOGhost邩ׂBȂ΁AGhost̖OIĕԂ
//	GhostOKAȂNGԂB
//---------------------------------------------------------------------------
int nasino_getghostname(char *ghostname,struct s20_data *commdata)
{
	int ret;
	S23_ghost *ghost;
	int loop;
	
//	strcpy(ghostname,"܂");
//	return(OK);

//	printf("nasino_getghostname\n");
	logwrite("nasino_getghostname\n");
	sprintf(LogTmp,"ghost_profile.ghost_num: %d:\n",ghost_profile.ghost_num);
	logwrite(LogTmp);
	if(ghost_profile.ghost_num == 0){
//		printf("GhostȂ\n");
		logwrite("GhostȂ\n");
		ret = NG;			// GhostȂ
	}else{
		ghost = ghost_profile.ghost_pointer;
		loop = ON;
		if(strlen(commdata->to) > 0){
			logwrite("̎w肪B\n");
			sprintf(LogTmp,"Ghost Name:%s\n",commdata->to);
			logwrite(LogTmp);
		// ̎w肪B̑肪邩`FbNB
			while((ghost->ghost_name != NULL) && (loop == ON)){
				if(strcmp(commdata->to,ghost->ghost_name) == 0){
//					printf("mach Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
//					sprintf(LogTmp,"Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
//					logwrite(LogTmp);
					strcpy(ghostname,ghost->ghost_name);		// ͂ȂGhost
					loop = OFF;
				}else{
					ghost = ghost->next_pointer;
//					printf("unmach Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
//					sprintf(LogTmp,"Ghost Name: %d:%s\n",ghost->ghost_name,ghost->ghost_name);
//					logwrite(LogTmp);
				}
			}
		}else{
			logwrite("̎w肪ȂB\n");
			
		}
		if(loop == ON){
		// ̎wȂB͈GhostȂBGhostKɑIB
			strcpy(ghostname,ghost->ghost_name);		// ͂ȂGhost ߂ă_ɑIׂł́B
		}
		ret = OK;
	}
	
	logwrite("ret");
	return(ret);
	
}

//---------------------------------------------------------------------------
//		 SHIORI/2.3 Communicate
//
//		answerdata->sentence		OUT		쐬ԓ
//		answerdata->to				OUT		ԓ̖O
//		answerdata->version			OUT		vgRo[W
//		answerdata->code			OUT		ԓpR[h
//		s20_data commdata		IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret					OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s23ghostcomminucate(struct s20_data *answerdata,struct s20_data *commdata)
{
	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;						// ɍṽe[u
//	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
//	int sakura_objpoint = 0;							//
	
	int from_check;
	int to_check;
	int event_check;
	int sentence_check;
	int count0;
	int mode;
	int ret;

	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	
	S23_ghost *ghost;
	int loop;
	
	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
		// 
		word_count = nasino_tagwordcount(NASINO_TAG,tag_table,0);					// from ܂ތ
//		printf("word_count:%d\n",word_count);

		if(word_count > 0){
			if((dic_table = (int*)malloc(word_count))==NULL){
				// malloc error.
			}else{
//				check_sakurafillemappingdata(sakura_object,&sakura_objpoint);
				dic_tablepoint = 0;
				for(count0=0;tag_table[count0]<DicWordCount;count0++){
					get_dicword(&dicreaddata,tag_table[count0]);
//					printf("dic:%s:%s\n",dicreaddata.key,dicreaddata.word);

					// from ̒
					from_check = s20diccheck_from(dicreaddata,commdata);
//					printf("from_check:%d\n",to_check);
					// to ̒
					to_check = s20diccheck_to(dicreaddata,answerdata->to);			// ̒iKŁAb|鑊肪݂邩̌_͏oĂB
//					printf("to_check:%d\n",to_check);
					// event ̒
//					event_check = s20diccheck_event(dicreaddata,commdata);
					event_check = 1;
					// sentence ̒
					sentence_check = s20diccheck_sentence(dicreaddata,commdata);
					
					
					// ʓo^
					if((from_check == 1) && (to_check == 1) && (event_check == 1) && (sentence_check == 1)){
						to_check = 0;
						dic_table[dic_tablepoint] = tag_table[count0];
						dic_tablepoint++;
						printf("dicreaddata:%s:%s:\n",dicreaddata.key,dicreaddata.word);
//						sprintf(LogTmp,"dicreaddata:%s:%s:\n",dicreaddata.key,dicreaddata.word);
//						logwrite(LogTmp);
					}
					
				}
				printf("dic_tablepoint:%d:\n",dic_tablepoint);
				sprintf(LogTmp,"dic_tablepoint:%d:\n",dic_tablepoint);
				logwrite(LogTmp);
				
				for(count0=0;count0<dic_tablepoint;count0++){
					get_dicword(&dicreaddata,dic_table[count0]);
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
				}

				// Mf[^쐬
				if(dic_tablepoint > 0){
					get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
					make_sentence(answerdata->sentence,dicreaddata.word,0);
					printf("nasino_s23ghostcomminucate:%s\n",answerdata->sentence);
					sprintf(LogTmp,"nasino_s23ghostcomminucate:%s:\n",answerdata->sentence);
					logwrite(LogTmp);
					
//					answerdata->version = 23;
//					answerdata->code = 200;
					
					ret = OK;
					logwrite("OK\n");
				}else{
					ret = NG;
					logwrite("NG\n");
				}
				free(dic_table);
			}
		}

		free(tag_table);
	}

	return(ret);
}

int nasino_s23ghostcomminucate_new(struct s20_data *answerdata,struct s20_data *commdata)
{
	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;						// ɍṽe[u
//	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
//	int sakura_objpoint = 0;							//
	
	int from_check;
	int to_check;
	int event_check;
	int sentence_check;
	int count0;
	int mode;
	int ret;

	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	
	S23_ghost *ghost;
	int loop;
	
	char tag_tmp[DicBufferLength];
	unsigned int count1;
	
	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
		// 
		
//		word_count = nasino_tagwordcount(NASINO_TAG,tag_table,0);					// from ܂ތ
		word_count = 0;
		for(count1=0;count1<DicWordCount;count1++){
			get_dicword(&dicreaddata,count1);
//			printf("dicreaddata:%s\n",dicreaddata.key);
			getkeyword_one(tag_tmp,dicreaddata.key);
//			printf("tag_tmp:%s\n",tag_tmp);
			if((strcmp(tag_tmp,NASINO_TAG) == 0) && (strstr(dicreaddata.key,"to[") != NULL) ){		// to^OK{ƂB
				printf("tag_tmp:%s\n",tag_tmp);
				// from ̒
				from_check = s20diccheck_from(dicreaddata,commdata);
//				printf("from_check:%d\n",to_check);
				// to ̒
				to_check = s20diccheck_to(dicreaddata,answerdata->to);			// ̒iKŁAb|鑊肪݂邩̌_͏oĂB
//				printf("to_check:%d\n",to_check);
				// sentence ̒
				sentence_check = s20diccheck_sentence(dicreaddata,commdata);
				
				
				// ʓo^
				if((from_check == 1) && (to_check == 1) && (sentence_check == 1)){
					printf("Mach!:%s:%s:---\n",dicreaddata.key,dicreaddata.word);
//					printf("keycode1 : %s :: %s :: %s\n",tag_tmp,dicreaddata.key,dicreaddata.word);
//					sprintf(LogTmp,"Mach! keycode0 : %s :: %s :: %s\n",tag,dicreaddata.key,dicreaddata.word);
//					logwrite(LogTmp);
					tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
					word_count++;
				}
			}
		}
		tag_table[word_count] = DicWordCount + 1;		// ^[~l[^o^
		printf("word_count:%d:%d\n",DicWordCount,word_count);
//		printf("word_count:%d\n",word_count);

		// Mf[^쐬
		if(dic_tablepoint > 0){
			get_dicword(&dicreaddata,tag_table[nasino_random(word_count)]);
			printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
//			make_sentence(answerdata->sentence,dicreaddata.word,0);
			strcpy(commdata->buffer,dicreaddata.word);
			make_sentence2(answerdata,commdata,0);
//			printf("nasino_s23ghostcomminucate:%s\n",answerdata->sentence);
//			sprintf(LogTmp,"nasino_s23ghostcomminucate:%s:\n",answerdata->sentence);
//			logwrite(LogTmp);
			
//			answerdata->version = 23;
//			answerdata->code = 200;
			
			ret = OK;
			logwrite("OK\n");
		}else{
			ret = NG;
			logwrite("NG\n");
		}

		free(tag_table);
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		 SHIORI/2.1 Communicate
//
//		answerdata->sentence		OUT		쐬ԓ
//		answerdata->targetHWnd		OUT		ԓHWndBw肵Ȃꍇ""
//		answerdata->version			OUT		vgRo[W
//		answerdata->code			OUT		ԓpR[h
//		s20_data commdata		IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret					OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int nasino_s20makeanswer(struct s20_data *answerdata,struct s20_data commdata)
{

	dic_readdata dicreaddata;
	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int *dic_table;
	int dic_tablepoint;						// ɍṽe[u
	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
	int sakura_objpoint = 0;							//
	
	int from_check;
	int to_check;
	int event_check;
	int sentence_check;
	int count0;
	int mode;
	int ret;

	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	logwrite("--- nasino_s20makeanswer\n");

	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
	
		word_count = nasino_tagwordcount(NASINO_TAG,tag_table,0);					// from ܂ 

		if(word_count > 0){
			if((dic_table = (int*)malloc(word_count))==NULL){
				// malloc error.
			}else{
//				check_sakurafillemappingdata(sakura_object,&sakura_objpoint);
				dic_tablepoint = 0;
				for(count0=0;tag_table[count0]<DicWordCount;count0++){
					get_dicword(&dicreaddata,tag_table[count0]);
					printf("dic:%s:%s\n",dicreaddata.key,dicreaddata.word);

					// from ̒
					from_check = s20diccheck_from(dicreaddata,&commdata);
					// to ̒
//					to_check = s20diccheck_to(dicreaddata,sakura_object,sakura_objpoint);			// ̒iKŁAb|鑊肪݂邩̌_͏oĂB
					to_check = 0;
					// event ̒
					event_check = s20diccheck_event(dicreaddata,&commdata);
					// sentence ̒
					sentence_check = s20diccheck_sentence(dicreaddata,&commdata);
					
					
					// ʓo^
					if((from_check == 1) && (to_check == 1) && (event_check == 1) && (sentence_check == 1)){
						dic_table[dic_tablepoint] = tag_table[count0];
						dic_tablepoint++;
						sprintf(LogTmp,"dicreaddata:%s:%s:\n",dicreaddata.key,dicreaddata.word);
						logwrite(LogTmp);
					}
					printf("dic_tablepoint:%d\n",dic_tablepoint);
					
				}
				sprintf(LogTmp,"dic_tablepoint:%d:\n",dic_tablepoint);
				logwrite(LogTmp);

				if(dic_tablepoint > 0){
					get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);
					printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
					make_sentence(answerdata->sentence,dicreaddata.word,0);
					printf("%s\n",answerdata->sentence);
					sprintf(LogTmp,"3: nasino_s21communicate:%s:\n",answerdata->sentence);
					logwrite(LogTmp);
					
					mode = s21gettargetghost(answerdata->targetHWnd,dicreaddata,sakura_object,sakura_objpoint);
					sprintf(LogTmp,"answerdata->targetHWnd:%s:\n",answerdata->targetHWnd);
					logwrite(LogTmp);

//					if(mode == OK){										// to BSHIORI/2.1 310 Communicate
						answerdata->version = 21;
						answerdata->code = 310;
//					}else{												// SHIORI/2.0 200 OK
//						answerdata->version = 20;
//						answerdata->code = 200;
//					}
					ret = OK;
					logwrite("OK\n");
				}else{
					ret = NG;
					logwrite("NG\n");
				}
				free(dic_table);
			}
		}

		free(tag_table);
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		ؘa Phase5 Communicate
//
//		*answer				OUT		쐬
//		*buffer				IN		̓f[^ij󂵂Ă͂ȂȂj
//		int ret				OUT		OK:쐬 NG:쐬ł
//---------------------------------------------------------------------------
int kawari5com(char *answer,char *buffer)
{
	dic_readdata dicreaddata;
	char buffer_tmp[AnswerLength];
	char kawari_tag[DicBufferLength];
	char tagtmp[DicBufferLength];
	char tagtmp2[DicBufferLength];
	char word[DicBufferLength];
	
	char calc[DicBufferLength];
	char calctmp[DicBufferLength];

	int word_count;							// Ɋ܂܂Ώی̐
	int *tag_table;							// ɂΏۂ̃e[u
	int taglength;							// pointer
	int temp;
	int *dic_table;
	int dic_tablepoint;
	
	int count1;
	int ret;
	
	strcpy(buffer_tmp,buffer);						// bufferj󂵂Ă͂ȂB
	
		if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
			// malloc error.
		}else{
		
			sprintf(kawari_tag,"%s[",KAWARI_TAG);			// b菈uBؘaCommunicate^OčlB@F蔲c
//			sprintf(kawari_tag,"nasino communicate");			// b菈uBؘaCommunicate^OčlB@F蔲c
		
			word_count = tagwordcount(kawari_tag,tag_table);
//			word_count = nasino_tagwordcount(kawari_tag,tag_table,1);					// from ܂܂Ȃ
			if(word_count > 0){
				if((dic_table = (int*)malloc(word_count))==NULL){
					// malloc error.
				}else{
					dic_tablepoint = 0;
					taglength = strlen(kawari_tag);
			
					for(count1=0;tag_table[count1]<DicWordCount;count1++){
						get_dicword(&dicreaddata,tag_table[count1]);
						printf("kawari5com %d::%s::%s\n",tag_table[count1],dicreaddata.key,dicreaddata.word);
					
						strcpy(tagtmp,&dicreaddata.key[taglength]);
						temp = strlen(tagtmp);
						if(tagtmp[strlen(tagtmp)-1] == ']'){			// []^Om
							tagtmp[strlen(tagtmp)-1] = '\0';
							printf("tagtmp:%s:\n",tagtmp);
						
							strcpy(tagtmp2,tagtmp);						// []̒go
							strcpy(calc,"");
							logic_make(calc,tagtmp2,buffer_tmp,LOGIC_STRSTR);
							printf("calc:%s:%s:%d\n",buffer_tmp,calc,logic_calc(calc));
							if(logic_calc(calc) == 1){
								dic_table[dic_tablepoint] = tag_table[count1];
								dic_tablepoint++;
							}
						}	
					}
					
					if(dic_tablepoint > 0){
//						printf("dic_tablepoint:%d\n",dic_tablepoint);
//						for(count1=0;count1<dic_tablepoint;count1++){
//							get_dicword(&dicreaddata,dic_table[count1]);
//							printf("%s\n",dicreaddata.word);
//						}
					
						get_dicword(&dicreaddata,dic_table[nasino_random(dic_tablepoint)]);
						printf("%s:%s\n",dicreaddata.key,dicreaddata.word);
						make_sentence(answer,dicreaddata.word,0);
						printf("%s\n",answer);
						
						ret = OK;
					}else{
						ret = NG;
					}
						
					free(dic_table);
				}
			}
			free(tag_table);

		}
		
		
	printf("return:%d\n",ret);
	return(ret);

}

//---------------------------------------------------------------------------
//		[]̘̓_쐬B
//
//		*logic						OUT		쐬_
//		char *buffer				IN		̓f[^
//		unsigned int mode			IN		[h
//											LOGIC_STRCMP	Sv
//											LOGIC_STRSTR	ꂪ܂܂邩ۂB
//---------------------------------------------------------------------------
int logic_make(char *logic,char *input,char *buffer,unsigned int mode)
{
	char word[DicBufferLength];
	char wordtmp[DicBufferLength];
	int ret;

//	printf("--- logic_make ---\n");
	logwrite("--- logic_make ---\n");
	do{
		getcalcword(wordtmp,input);
		printf("getcalcword:%s\n",wordtmp);
		if(getbufentry(word,wordtmp) == OK){					// ${}܂܂ĂAgo
			strcpy(wordtmp,word);
		}
		if(tagchange(word,wordtmp,0) == NG){
			strcpy(word,wordtmp);
		}
//		printf("tagchange:%s:%s:\n",wordtmp,word);
		sprintf(LogTmp,"tagchange:%s:%s:\n",wordtmp,word);
		logwrite(LogTmp);
		if(strlen(word)>0){
			if(strcmp(word,",") == 0){
				strcpy(word,"&");
			}
//			printf("word:%s\n",word);
			if((strcmp(word,"&")==0) || (strcmp(word,"|")==0) || (strcmp(word,"!")==0) || (strcmp(word,"^")==0)
			|| (strcmp(word,"(")==0) || (strcmp(word,")")==0)){
				strcat(logic,word);
			}else{
				if(mode == LOGIC_STRCMP){
					if(strcmp(buffer,word) == 0){					// buffer_tmp wordv邩B
						strcat(logic,"1");
					}else{
						strcat(logic,"0");
					}
				}else if(mode == LOGIC_STRSTR){
					if(strstr(buffer,word) != NULL){				// buffer_tmp word܂܂邩B
						strcat(logic,"1");
					}else{
						strcat(logic,"0");
					}
				}else{
				}
			}
		}
	}while(strlen(input)>0);				// _쐬
//	printf("logic_make:%s:\n",logic);
	sprintf(LogTmp,"logic_make:%s:%s:%s:\n",logic,input,buffer);
	logwrite(LogTmp);
	
	return(ret);
}


//---------------------------------------------------------------------------
//		^ꂽɍvnasino^Ǒꂪ邩ׂ
//		keynasinoŎn܂Atag܂܂𒊏o
//
//		*tag_table		OUT		Pe[u
//		*tag			IN		tagɊ܂܂
//		mode			IN		ǉ	0:Ȃ
//											1:from܂܂Ȃ
//---------------------------------------------------------------------------
int nasino_tagwordcount(char* tag,int *tag_table,int mode)
{
	int word_count;
	int count1;
	char word_tmp[DicBufferLength];				/* ؂odata */
	char tag_tmp[DicBufferLength];				/* tag */
	
	dic_readdata dicreaddata;
	
	word_count = 0;
	for(count1=0;count1<DicWordCount;count1++){
		get_dicword(&dicreaddata,count1);
//		printf("dicreaddata:%s\n",dicreaddata.key);
		memcpy(tag_tmp,dicreaddata.key,strlen(NASINO_TAG));
		tag_tmp[strlen(NASINO_TAG)] = '\0';
//		printf("tag_tmp:%s\n",tag_tmp);
		if((strcmp(tag_tmp,NASINO_TAG) == 0) && (strstr(dicreaddata.key,tag) != NULL)){
			if(mode == 0){
//				printf("keycode1 : %s :: %s :: %s\n",tag_tmp,dicreaddata.key,dicreaddata.word);
//				sprintf(LogTmp,"Mach! keycode0 : %s :: %s :: %s\n",tag,dicreaddata.key,dicreaddata.word);
//				logwrite(LogTmp);
				tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
				word_count++;
			}else if((mode == 1) && (strstr(dicreaddata.key,FROM_TAG) == NULL)){	// from܂܂Ȃ
//				printf("keycode1 : %s :: %s :: %s\n",tag_tmp,dicreaddata.key,dicreaddata.word);
//				sprintf(LogTmp,"Mach! keycode1 : %s :: %s :: %s\n",tag,dicreaddata.key,dicreaddata.word);
//				logwrite(LogTmp);
				tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
				word_count++;
			}
		}
	}
	tag_table[word_count] = DicWordCount + 1;		// ^[~l[^o^
	printf("word_count:%d:%d\n",DicWordCount,word_count);
	

	return(word_count);
}

//---------------------------------------------------------------------------
//		ɍv鎫̌𒊏oB
//		keynasinoŎn܂Atag܂܂𒊏o
//
//		*tag_table		OUT		Pe[u
//		*tag			IN		tagɊ܂܂
//		mode			IN		ǉ	0:Ȃ
//											1:from܂܂Ȃ
//---------------------------------------------------------------------------
int nasino_eventmachcount(int *tag_table,struct s20_data commdata,int mode)
{
	int word_count;
	int count1;
	int count2;
//	char word_tmp[DicBufferLength];				/* ؂odata */
//	char tag_tmp[DicBufferLength];				/* tag */
//	char tag_tmp2[DicBufferLength];				/* tag */
	char *tag_tmp;				/* tag */
	char *tag_tmp2;				/* tag */
	char *reference_pointer[ReferenceNum];
	
	char reference_tag[11];
	unsigned int flug;
	char* point;
//	char logic[DicBufferLength];
	char *logic;
	
	int ret;
	dic_readdata dicreaddata;
	
	tag_tmp = (char*)malloc(sizeof(char) * DicBufferLength);
	tag_tmp2 = (char*)malloc(sizeof(char) * DicBufferLength);
	logic = (char*)malloc(sizeof(char) * DicBufferLength);
	
	
	
	printf("--- nasino_eventmachcount ---\n");
	logwrite("--- nasino_eventmachcount ---\n");

	reference_pointer[0] = commdata.reference0;
	reference_pointer[1] = commdata.reference1;
	reference_pointer[2] = commdata.reference2;
	reference_pointer[3] = commdata.reference3;
	reference_pointer[4] = commdata.reference4;
	reference_pointer[5] = commdata.reference5;
	reference_pointer[6] = commdata.reference6;
	reference_pointer[7] = commdata.reference7;

	word_count = 0;
	for(count1=0;count1<DicWordCount;count1++){
		get_dicword(&dicreaddata,count1);
//		printf("dicreaddata:%s:%s\n",dicreaddata.key,dicreaddata.word);
		getkeyword_one(tag_tmp,dicreaddata.key);
		getkeyword_one(tag_tmp2,dicreaddata.key);
//		printf("tag_tmp:%s:%s\n",tag_tmp,tag_tmp2);
//		sprintf(LogTmp,"%d:tag_tmp:%s:%s\n",count1,tag_tmp,tag_tmp2);
//		logwrite(LogTmp);
		if((strcmp(tag_tmp,NASINO_TAG) == 0) && (strcmp(tag_tmp2,EVENT_TAG) == 0)){
//			printf("tag_tmp2:%s:%s:%s\n",tag_tmp,tag_tmp2,dicreaddata.key);
			getkeyword_one(tag_tmp,dicreaddata.key);
			if(strcmp(tag_tmp,commdata.event) == 0){
//				printf("OK\n");
				flug = ON;
				for(count2=0;count2<ReferenceNum;count2++){						// reference0`7̕]
					sprintf(reference_tag,"reference%d",count2);
//					printf("referencetag:%s:\n",reference_tag);
//					sprintf(LogTmp,"referencetag:%s:\n",reference_tag);
//					logwrite(LogTmp);
					point = strstr(dicreaddata.key,reference_tag);
//					printf(":%s::%d\n",dicreaddata.key,count2);
//					sprintf(LogTmp,":%s::%d\n",dicreaddata.key,count2);
//					logwrite(LogTmp);
					if(point != NULL){											// reference̕]
						logwrite("Strstr OK!!\n");
						getbufconditional(tag_tmp,point);						// [ ]̒g肾
//						printf("tagtmp:%s:\n",tag_tmp);
//						sprintf(LogTmp,"tagtmp:%s:\n",tag_tmp);
//						logwrite(LogTmp);
					
						strcpy(logic,"");
						logic_make(logic,tag_tmp,reference_pointer[count2],LOGIC_STRCMP);	// SvŘ_쐬
//						printf("calc:%s:%s:%s:%d:%s\n",reference_pointer[count2],tag_tmp,logic,logic_calc(logic),dicreaddata.word);
//						sprintf(LogTmp,"calc:%s:%s:%s:%d:%s\n",reference_pointer[count2],tag_tmp,logic,logic_calc(logic),dicreaddata.word);
//						logwrite(LogTmp);
						if(logic_calc(logic) == 1){
//							flug = ON;
							printf("OK!\n");
							printf("OK calc:%s:%s:%s:%d:%s\n",reference_pointer[count2],tag_tmp,logic,logic_calc(logic),dicreaddata.word);
						}else{
							flug = OFF;
							printf("NG!\n");
							printf("NG calc:%s:%s:%s:%d:%s\n",reference_pointer[count2],tag_tmp,logic,logic_calc(logic),dicreaddata.word);
						}
					}
				}
				if(flug == ON){
					printf("keycode1 : %s :: %s :: %s\n",tag_tmp,dicreaddata.key,dicreaddata.word);
					sprintf(LogTmp,"Mach! keycode0 : %s :: %s :: %s\n",commdata.event,dicreaddata.key,dicreaddata.word);
					logwrite(LogTmp);
					tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
					word_count++;
				}
			}
		}
	}
	tag_table[word_count] = DicWordCount + 1;		// ^[~l[^o^
//	printf("word_count:%d:%d\n",DicWordCount,word_count);
	
	free(tag_tmp);
	free(tag_tmp2);
	free(logic);

	return(word_count);
}



//---------------------------------------------------------------------------
//		sentenceŕ]B
//
//		dic_readdata dicreaddata	IN		
//		s20_data commdata			IN		]p͕
//---------------------------------------------------------------------------
int s20diccheck_sentence(struct dic_readdata dicreaddata,struct s20_data *commdata)
{
	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	int ret;

	// sentence ̒
	strcpy(logic,"");
	point = strstr(dicreaddata.key,SENTENCE_TAG);
	if(point != NULL){										// sentence[ ]@邩
		point += strlen(SENTENCE_TAG);
		getbufconditional(word,point);						// [ ]̒g肾
		printf("sentence_word:%s\n",word);
		logic_make(logic,word,commdata->sentence,LOGIC_STRSTR);
		printf("sentence_calc:%s:%s:%d\n",commdata->sender,logic,logic_calc(logic));
		ret = logic_calc(logic);
	}else{													// sentence[]΁AɃ}b`
		ret = 1;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		fromŕ]B
//
//		dic_readdata dicreaddata	IN		
//		s20_data commdata			IN		]p͕
//---------------------------------------------------------------------------
int s20diccheck_from(struct dic_readdata dicreaddata,struct s20_data *commdata)
{
	char word[WordLength];
	char* point;
	char logic[DicBufferLength];

	int ret;

	// sentence ̒
	strcpy(logic,"");
	point = strstr(dicreaddata.key,FROM_TAG);
	if(point != NULL){										// from[ ]@邩
		point += strlen(FROM_TAG);
		getbufconditional(word,point);						// [ ]̒g肾
		printf("from_word:%s\n",word);
		logic_make(logic,word,commdata->sender,LOGIC_STRSTR);
		printf("from_calc:%s:%s:%d\n",commdata->sender,logic,logic_calc(logic));
		ret = logic_calc(logic);
	}else{													// from[]΁AɃ}b`
		ret = 1;
	}

	return(ret);
}


//---------------------------------------------------------------------------
//		eventŕ]B
//
//		dic_readdata dicreaddata	IN		
//		s20_data commdata			IN		]p͕
//---------------------------------------------------------------------------
int s20diccheck_event(struct dic_readdata dicreaddata,struct s20_data commdata)
{
	char word[WordLength];
	char* point;
	char logic[DicBufferLength];
	char reference_tag[DicBufferLength];
	char tagtmp[DicBufferLength];

	int flug;
	int count1;
	int calc_answer;
	int ret;
	char *reference_pointer[ReferenceNum];
	char *point2;

	reference_pointer[0] = commdata.reference0;
	reference_pointer[1] = commdata.reference1;
	reference_pointer[2] = commdata.reference2;
	reference_pointer[3] = commdata.reference3;
	reference_pointer[4] = commdata.reference4;
	reference_pointer[5] = commdata.reference5;
	reference_pointer[6] = commdata.reference6;
	reference_pointer[7] = commdata.reference7;

	logwrite("s20diccheck_event\n");
	
	// event ̒
	strcpy(logic,"");
	point = strstr(dicreaddata.key,EVENT_TAG);
	if(point != NULL){										// event@邩
		point += strlen(EVENT_TAG);
		getbufpword(word,point);							// Cxgʎq肾
//		sprintf(LogTmp,"word:%s:%s:%s\n",word,commdata.event,dicreaddata.key);
//		logwrite(LogTmp);
		if(strcmp(word,commdata.event) == 0){
			sprintf(LogTmp,"calc OK:%s:%s:%s\n",word,commdata.event,dicreaddata.key);
			logwrite(LogTmp);
			flug = ON;
			for(count1=0;count1<ReferenceNum;count1++){						// reference0`7̕]
				sprintf(reference_tag,"reference%d",count1);
//				printf("referencetag:%s:\n",reference_tag);
				sprintf(LogTmp,"referencetag:%s:\n",reference_tag);
				logwrite(LogTmp);
				point = strstr(dicreaddata.key,reference_tag);
//				printf(":%s::%d\n",dicreaddata.key,count1);
				sprintf(LogTmp,":%s::%d\n",dicreaddata.key,count1);
				logwrite(LogTmp);
				if(point != NULL){											// reference̕]
					logwrite("Strstr OK!!\n");
					getbufconditional(tagtmp,point);						// [ ]̒g肾
//					printf("tagtmp:%s:\n",tagtmp);
					sprintf(LogTmp,"tagtmp:%s:\n",tagtmp);
					logwrite(LogTmp);
					
					strcpy(logic,"");
					logic_make(logic,tagtmp,reference_pointer[count1],LOGIC_STRCMP);	// SvŘ_쐬
//					printf("calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
					sprintf(LogTmp,"calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
					logwrite(LogTmp);
					if(logic_calc(logic) == 1){
//						flug = ON;
					}else{
						flug = OFF;
					}
				}else{
//					printf("%s nocalc.\n",reference_tag);
//					flug = OFF;
				}
			}
			if(flug == ON){
//				sprintf(LogTmp,"calc OK!!!:%s:%s:%s\n",word,commdata.event,dicreaddata.key);
//				logwrite(LogTmp);
				ret = 1;
			}else{
				ret = 0;
			}
					
		}else{
//			logwrite("Calc NG!!\n");
			ret = 0;
		}
		
	}else{													// event[]΁AɃ}b`
		ret = 1;
	}
//	printf("s20diccheck_event return:%d\n",ret);
	return(ret);
}

/*
int s20diccheck_event_old(struct dic_readdata dicreaddata,struct s20_data commdata)
{
	char word[WordLength];
	char* point;
	char logic[DicBufferLength];
	char reference_tag[DicBufferLength];
	char tagtmp[DicBufferLength];

	int flug;
	int count1;
	int calc_answer;
	int ret;
	char *reference_pointer[ReferenceNum];
	char *point2;

	reference_pointer[0] = commdata.reference0;
	reference_pointer[1] = commdata.reference1;
	reference_pointer[2] = commdata.reference2;
	reference_pointer[3] = commdata.reference3;
	reference_pointer[4] = commdata.reference4;
	reference_pointer[5] = commdata.reference5;
	reference_pointer[6] = commdata.reference6;
	reference_pointer[7] = commdata.reference7;

//	logwrite("s20diccheck_event\n");
	
	// event ̒
	strcpy(logic,"");
	point = strstr(dicreaddata.key,EVENT_TAG);
	if(point != NULL){										// event[ ]@邩
		point += strlen(EVENT_TAG);
		getbufpword(word,point);						// [ ]̒g肾
//		printf("EVENT_TAG_word:%s\n",word);
////		logic_make(logic,word,commdata.event);
		calc_answer = logic_calc(logic);
//		printf("EVENT_TAG_calc:%s:%s:%d\n",commdata.event,logic,logic_calc(logic));
//		sprintf(LogTmp,"EVENT_TAG_calc:%s:%s:%d:%s\n",commdata.event,logic,calc_answer,dicreaddata.key);
//		logwrite(LogTmp);
		
		if(calc_answer == 1){
//			logwrite("Calc OK!!\n");
			flug = ON;
			for(count1=0;count1<ReferenceNum;count1++){						// reference0`7̕]
				sprintf(reference_tag,"reference%d",count1);
//				printf("referencetag:%s:\n",reference_tag);
//				sprintf(LogTmp,"referencetag:%s:\n",reference_tag);
//				logwrite(LogTmp);
				point = strstr(dicreaddata.key,reference_tag);
//				printf(":%s::%d\n",dicreaddata.key,count1);
//				sprintf(LogTmp,":%s::%d\n",dicreaddata.key,count1);
//				logwrite(LogTmp);
				if(point != NULL){											// reference̕]
//					logwrite("Strstr OK!!\n");
					getbufconditional(tagtmp,point);						// [ ]̒g肾
//					printf("tagtmp:%s:\n",tagtmp);
//					sprintf(LogTmp,"tagtmp:%s:\n",tagtmp);
//					logwrite(LogTmp);
					
					strcpy(logic,"");
////					logic_make(logic,tagtmp,reference_pointer[count1]);
//					printf("calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
//					sprintf(LogTmp,"calc:%s:%s:%s:%d:%s\n",reference_pointer[count1],tagtmp,logic,logic_calc(logic),dicreaddata.word);
//					logwrite(LogTmp);
					if(logic_calc(logic) == 1){
//						flug = ON;
					}else{
						flug = OFF;
					}
				}else{
//					printf("%s nocalc.\n",reference_tag);
//					flug = OFF;
				}
			}
			if(flug == ON){
				ret = 1;
			}else{
				ret = 0;
			}
					
		}else{
			ret = 0;
		}
		
	}else{													// event[]΁AɃ}b`
		ret = 1;
	}
	printf("s20diccheck_event return:%d\n",ret);
	return(ret);
}
*/

//---------------------------------------------------------------------------
//		toŕ]B
//
//		dic_readdata dicreaddata	IN		
//		s20_data commdata			IN		]p͕
//---------------------------------------------------------------------------
//int s20diccheck_to(struct dic_readdata dicreaddata,struct sakura_mapdat *sakura_object,int sakura_objpoint)
int s20diccheck_to(struct dic_readdata dicreaddata,char *ghostname)
{
	char word[WordLength];
	char* point;
	char logic[DicBufferLength];
	char ghostlist[WordLength];

	int count1;
	int ret;
	
	ret = 0;
//	return(0);

//	strcpy(ghostlist,ENTRY_ANYONE);
//	for(count1=0;count1<sakura_objpoint;count1++){
//		strcat(ghostlist,",");
//		strcat(ghostlist,sakura_object[count1].name);
//	}
	
	sprintf(ghostlist,"%s | %s",ghostname,ENTRY_ANYONE);

	// to ̒
	strcpy(logic,"");
	point = strstr(dicreaddata.key,TO_TAG);
	if(point != NULL){										// to[ ]@邩
		point += strlen(TO_TAG);
		getbufconditional(word,point);						// [ ]̒g肾
		printf("to_word:%s\n",word);
	printf("s20diccheck_to:%s\n",ghostlist);
//	sprintf(LogTmp,"s20diccheck_to:%s:%s\n",word,ghostlist);
//	logwrite(LogTmp);
	
		logic_make(logic,word,ghostlist,LOGIC_STRSTR);
		printf("to_calc:%s:%s:%d\n",ghostlist,logic,logic_calc(logic));
		ret = logic_calc(logic);
	}else{													// to[]΁A}b`Ȃ
		ret = 0;
	}
	return(ret);
}

//---------------------------------------------------------------------------
//
//		Nɘb邩߂
//
//		ret			OUT		OK:hWnd擾		NG:擾ł
//---------------------------------------------------------------------------
int s21gettargetghost(char *targetHWnd,struct dic_readdata dicreaddata,struct sakura_mapdat *sakura_object,int sakura_objpoint)
{
	sakura_mapdat *ghostlist;
	int ghostlistpoint = 0;

	char word[WordLength];
	char* point;
	int count1;
	int loop;
	int ret;
	
	point = strstr(dicreaddata.key,TO_TAG);
	if(point != NULL){										// to[ ]@邩
		point += strlen(TO_TAG);
		getbufconditional(word,point);						// [ ]̒g肾
		printf("s21gettargetghost to:%s\n",word);
		
//		logic_make(logic,word,ghostlist);
//		printf("calc:%s:%s:%d\n",ghostlist,logic,logic_calc(logic));
//		ret = logic_calc(logic);

		if((ghostlist = (sakura_mapdat*)malloc(sizeof(sakura_mapdat) * sakura_objpoint))==NULL){
			// malloc error.
		}else{
			// gp\ghost
			
			count1 = 0;
			loop = ON;
			while((count1<sakura_objpoint) && (loop == ON)){
//				sprintf(LogTmp,"n_getresponse_targetHWnd:%s:%s:%d\n",sakura_object[count1].name,sakura_object[count1].hwnd);
//				logwrite(LogTmp);
				if(strcmp(ghost_profile.sakuraname,&sakura_object[count1].name[0]) != 0){					// ȊOɑ݂S[Xg̃Xg쐬
					strcpy(ghostlist[ghostlistpoint].name,sakura_object[count1].name);
					ghostlist[ghostlistpoint].hwnd = sakura_object[count1].hwnd;
					
					printf("s21gettargetghost:%d:%s:%d\n",ghostlistpoint,ghostlist[ghostlistpoint].name,ghostlist[ghostlistpoint].hwnd);
					sprintf(LogTmp,"s21gettargetghost:%d:%s:%d\n",ghostlistpoint,ghostlist[ghostlistpoint].name,ghostlist[ghostlistpoint].hwnd);
					logwrite(LogTmp);
					ghostlistpoint++;
//					loop = OFF;
				}
				count1++;
			}
			
			// ڕWghost
			if(strcmp(word,ENTRY_ANYONE) == 0){										// 肵Ȃ
				sprintf(targetHWnd,"%d",ghostlist[nasino_random(ghostlistpoint)].hwnd);
			}else{
				ret = NG;
				for(count1=0;count1<ghostlistpoint;count1++){
					if(strcmp(word,&ghostlist[count1].name[0]) == 0){				// ̑T
						sprintf(targetHWnd,"%d",ghostlist[count1].hwnd);
						ret = OK;
					}
				}
			}
			printf("s21gettargetghost to:%s,%s\n",word,targetHWnd);
			
			free(ghostlist);
		}
		ret = OK;
	}else{
		ret = NG;			// to[ ]B
	}
	
	if(ret == NG){
		strcpy(targetHWnd,"");
	}

	return(ret);
}
