//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.01.17
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include "shiori_dll.h"
#include "nasino.h"
#include "nasino_script.h"
#include "saori.h"
#include "sstp.h"
#include "nasino_sccomm.h"

extern char LogTmp[AnswerLength];
extern symbol script_symbols;					// ϐi[̈
extern ghost_data ghost_profile;								// GhostɊւf[^
extern char DataPath[PathLength];						/* ghostpath */

#define	STKSIZE		5000					// ԃR[hspX^bNTCY
extern int stack[STKSIZE];					// ԃR[hspGA
extern int stack_datatype[STKSIZE];

extern Saori_data saori_data;


//---------------------------------------------------------------------------
//		add
//---------------------------------------------------------------------------
int nasino_sccom_add(int *sp)
{
	int ret;
	int temp1,temp2,temp3;

	ret = OK;

	--(*sp);
	temp1 = nasino_script_getstackval(*sp);
	temp2 = nasino_script_getstackval(*sp + 1);
	temp3 = temp1 + temp2;
	nasino_script_setstackval(*sp,temp3,TYPE_NUM);

//	printf("ADD:%d + %d = %d:%d\n",temp1,temp2,nasino_script_getstackval(*sp),temp3);
//	sprintf(LogTmp,"ADD:%d + %d = %d:%d\n",temp1,temp2,nasino_script_getstackval(*sp),temp3);
//	script_logwrite(LogTmp);

	return(ret);
}

//---------------------------------------------------------------------------
//		strcpy()
//---------------------------------------------------------------------------
int nasino_sccom_strcpy(int *sp)
{
	int ret;
	char *string1;

	ret = OK;

	printf("-- STRCPY --\n");

	string1 = nasino_script_getstackstring(sp);
	(*sp)--;
	ret = nasino_script_setstackstring(sp,string1);
	(*sp)--;

	return(ret);
}


//---------------------------------------------------------------------------
//		strcat()
//---------------------------------------------------------------------------
int nasino_sccom_strcat(int *sp)
{
	int ret;

	ret = OK;

	return(ret);
}


//---------------------------------------------------------------------------
//		strcmp()
//---------------------------------------------------------------------------
int nasino_sccom_strcmp(int *sp)
{
	int ret;

	ret = OK;

	return(ret);
}


//---------------------------------------------------------------------------
//		atoi()
//---------------------------------------------------------------------------
int nasino_sccom_atoi(int *sp)
{
	int ret;

	ret = OK;

	return(ret);
}


//---------------------------------------------------------------------------
//		itoa()
//---------------------------------------------------------------------------
int nasino_sccom_itoa(int *sp)
{
	int ret;
	char string_tmp[16];
	int stack_tmp;

	ret = OK;

	itoa(nasino_script_getstackval(*sp),string_tmp,10);
	stack_tmp = script_symbols.push_string(string_tmp);
	nasino_script_setstackval(*sp,stack_tmp,TYPE_CHAR);	// ʂstackɐς

	return(ret);
}


//---------------------------------------------------------------------------
//		date()
//---------------------------------------------------------------------------
int nasino_sccom_date(int *sp)
{
	int ret;
	char *type;
	time_t long_time;
	struct tm *newtime;
	int stack_tmp;

	ret = OK;
	
	type = nasino_script_getstackstring(sp);
	time(&long_time);
	newtime = localtime(&long_time);
	if(strcmp(type,"%year") == 0){
		stack_tmp = newtime->tm_year + 1900;
	}else if(strcmp(type,"%month") == 0){
		stack_tmp = newtime->tm_mon + 1;
	}else if(strcmp(type,"%day") == 0){
		stack_tmp = newtime->tm_mday;
	}else if(strcmp(type,"%hour") == 0){
		stack_tmp = newtime->tm_hour;
	}else if(strcmp(type,"%minute") == 0){
		stack_tmp = newtime->tm_min;
	}else if(strcmp(type,"%second") == 0){
		stack_tmp = newtime->tm_sec;
	}else if(strcmp(type,"%wday") == 0){
		stack_tmp = newtime->tm_wday;
	}else{
		// error
		stack_tmp = 0;
		ret = NG;
	}
	nasino_script_setstackval(*sp,stack_tmp,TYPE_NUM);	// ʂstackɐς

	return(ret);
}


//---------------------------------------------------------------------------
//		rand()
//---------------------------------------------------------------------------
int nasino_sccom_rand(int *sp)
{
	int ret;
	char *ip;
	char *port;
	char *string;

	ret = OK;

	string = nasino_script_getstackstring((sp)--);
	port = nasino_script_getstackstring((sp)--);
	ip = nasino_script_getstackstring((sp)--);
	
//	printf("ip:%s port:%s string:%s\n",ip,port,string);
	
	sstp_send(ip,atoi(port),string);

	return(ret);
}

//---------------------------------------------------------------------------
//		saoricall()
//---------------------------------------------------------------------------
int nasino_sccom_saoricall(int *sp)
{
	int ret;
	char *dllname;
	int saori_argv;
	int saori_argcp;
	int saori_argc;
	
	int count;
	int len;
	char temp[16];

	char separater1[] = S20_Separater;
	char *buffer = NULL;
	
	char *point;
	char *word = NULL;
//	char word[1024];
	

	script_logwrite("nasino_sccom_saoricall\n");

	ret = OK;

//	printf("sp:%d\n",*sp);
	saori_argc = nasino_script_getstack(sp);
	(*sp)--;
//	printf("sp:%d\n",*sp);
	saori_argcp = nasino_script_getstackval((*sp)--);
	saori_argv = nasino_script_getstackval((*sp)--);
//	printf("saori_argv:%d saori_argcp:%d sp:%d\n",saori_argv,saori_argcp,*sp);
	dllname = nasino_script_getstackstring(sp);
	(*sp)--;
//	printf("sp:%d\n",*sp);
	
//	printf("dllname:%s saori_argv:%d saori_argc:%d\n",dllname,saori_argv,saori_argc);
//	sprintf(LogTmp,"dllname:%s saori_argv:%d saori_argc:%d\n",dllname,saori_argv,saori_argc);
//	script_logwrite(LogTmp);
	
	if(saori_argcp == -1){			// z̃|C^`FbNB
		len = 0;
		for(count=0;count<saori_argv;count++){
			sprintf(temp,"Argument%d: ",count);
			len += (strlen(temp) + strlen(nasino_script_getchardim(saori_argc,count)) + strlen(separater1));
			printf("%d dim:%d:%s\n",len,count,nasino_script_getchardim(saori_argc,count));
		}
		len += (strlen("EXECUTE SAORI/1.0") + strlen(separater1) + strlen("Sender: nasino") + strlen(separater1) + strlen("Charset: Shift_JIS") + strlen(separater1) + strlen(separater1) );
		printf("len:%d\n",len);
		
		if((buffer = (char*)malloc(len+1)) == NULL){
			ret = NG;
		}else{
			strcpy(buffer,"EXECUTE SAORI/1.0");
			strcat(buffer,separater1);
			for(count=0;count<saori_argv;count++){
				sprintf(temp,"Argument%d: ",count);
				strcat(buffer,temp);
				strcat(buffer,nasino_script_getchardim(saori_argc,count));	// ̎o
				nasino_script_setchardim(saori_argc,count,"");				// ̔z̃NA
				strcat(buffer,separater1);
			}
			strcat(buffer,"Sender: nasino");
			strcat(buffer,separater1);
			strcat(buffer,"Charset: Shift_JIS");
			strcat(buffer,separater1);
			strcat(buffer,separater1);
	
			printf("send data:%d\n%s\n",strlen(buffer),buffer);
			sprintf(LogTmp,"send data:%d\n%s\n",strlen(buffer),buffer);
			script_logwrite(LogTmp);
			
			if((saori_data.call_saori(dllname,buffer)) == OK){
			
				printf("return data:\n%s\n",buffer);
				sprintf(LogTmp,"return data:\n%s\n",buffer);
				script_logwrite(LogTmp);
				
				if((word = (char*)malloc(strlen(buffer)+1)) == NULL){
					ret = NG;
				}else{
					// G[`FbŃH
					
						point = strstr(buffer,"Result:");							// Result: ̎o
						if(point != NULL){
							point += strlen("Result:");
							getbufword0d(word,point);
							printf("Result:%s\n",word);
							nasino_script_setchardim(saori_argc,0,word);
						
							for(count=0;point!=NULL;count++){
								sprintf(temp,"Value%d: ",count);					// Value: ̎o
								point = strstr(buffer,temp);
								if(point != NULL){
									point += strlen(temp);
									getbufword0d(word,point);
									printf("%s:%s\n",temp,word);
									nasino_script_setchardim(saori_argc,count+1,word);
								}
							}
						
						}
				}
			}else{
				// SAORǏĂяos
				nasino_script_setchardim(saori_argc,0,"\"SAORI DLL Not Found.\"");
				nasino_script_setchardim(saori_argc,1,"\"SAORI DLL Not Found.\"");
					
			}
		}
	
	}else{
		printf("͔z̃|C^łȂ΂ȂȂB\n");
		ret = NG;
	}
	free(buffer);
	free(word);
	
	return(ret);
}
/*
int saorianswer_line_decode(char *buffer,int com_number)
{
	char word[1024];
	char tag[1024];
	static char *command[] = { "Result:","Charset:" };
	char *datapoint;
	char* point;
	int ret;
	
	point = strstr(buffer,command[com_number]);
	if(point != NULL){
		point += strlen(command[com_number]);

		getbufword0d(word,point);
//		printf("word:%s:%d\n",word,datapoint);
		if(strlen(word) > 0){
			datapoint = (char*)malloc(strlen(word)+1);
			strcpy(datapoint,word);
			ret = OK;
		}else{
			datapoint = (char*)malloc(1);
			strcpy(datapoint,"");
			ret = NG;
		}
		
		switch(com_number){
			case Hed_Sender:
				free(sender);
				sender = datapoint;
				break;
			case Hed_Charset:
				free(charset);
				charset = datapoint;
				break;
		}
	}else{
		ret = NG;
	}
	
	return(ret);

}
*/

//---------------------------------------------------------------------------
//		sstpsend()
//---------------------------------------------------------------------------
int nasino_sccom_sstpsend(int *sp)
{
	int ret;
	char *ip;
	char *port;
	char *string;

	ret = OK;

	string = nasino_script_getstackstring(sp);
	port = nasino_script_getstackstring(sp);
	ip = nasino_script_getstackstring(sp);
	
//	printf("ip:%s port:%s string:%s\n",ip,port,string);
	
	sstp_send(ip,atoi(port),string);

	return(ret);
}



//---------------------------------------------------------------------------
//		save()
//---------------------------------------------------------------------------
int nasino_sccom_save(int *sp)
{
	FILE *fp_dat;

	int ret;
//	char *filename;
	char filename[DataLength];
	int count1;
	int output;

	unsigned char sym[3];
	unsigned int symbol_len;
	char *buffer;
	char *buffer2;
	int buffer_len;
	unsigned int count2;

	script_logwrite("-- save --\n");

	ret = OK;
	buffer = NULL;
	buffer2 = NULL;

//	filename = nasino_script_getstackstring(sp);

	printf("save:%s\n",filename);
	sprintf(filename,"%s%s",DataPath,nasino_script_getstackstring(sp));

	if((fp_dat = fopen(filename,"wt"))==NULL){
		/* nasino.ini don't open!! */
		printf("testlogfile don't open!!\n");
		return(0);
	}else{
	
		for(count1=Reserve_Num;count1<(Reserve_Num+script_symbols.read_num());count1++){
			output = ON;
			if(script_symbols.get_symbol_type(count1) == TYPE_INT){
				sprintf(LogTmp,"INT : %s : %d\n",script_symbols.get_symbol_name(count1),script_symbols.get_symbol_val(count1));
			}else if(script_symbols.get_symbol_type(count1) == TYPE_CHAR){
			// \n \\nɕϊKv
				if((buffer = (char*)malloc(strlen(script_symbols.get_symbol_str(count1))+1))==NULL){
					// malloc error.
					printf("malloc error.\n");
				}else{
					strcpy(buffer,script_symbols.get_symbol_str(count1));
					buffer_len = 0;
					for(count2=0;count2<strlen(buffer);){		// 1pass KvƂȂobt@eʂvZ
						symbol_len = chksymsj(sym,&buffer[count2]);
						if(symbol_len == 1){
							int count_tmp;
							if( (sym[0] == '\"') || (sym[0] == '\n') || (sym[0] == '\r') ){
								count_tmp = 3;					// \\" ƃGXP[v镶
							}else{
								count_tmp = 1;
							}
							buffer_len = buffer_len + count_tmp;
						}else{
							buffer_len = buffer_len + symbol_len;
						}
						count2 = count2 + symbol_len;
					}
					
					if((buffer2 = (char*)malloc(buffer_len + 1))==NULL){
						// malloc error.
						printf("malloc error.\n");
					}else{
						strcpy(buffer2,"");
						for(count2=0;count2<strlen(buffer);){	// 2pass GXP[vR[hϊ
							symbol_len = chksymsj(sym,&buffer[count2]);
							if(symbol_len == 1){
								int count_tmp;
								if(sym[0] == '\"'){
									strcat(buffer2,"\\\"");
								}else if(sym[0] == '\n'){
									strcat(buffer2,"\\\\n");
								}else if(sym[0] == '\r'){
									strcat(buffer2,"\\\\r");
								}else{
									strcat(buffer2,sym);
								}
							}else{
								strcat(buffer2,sym);
							}
							count2 = count2 + symbol_len;
						}
						buffer2[buffer_len] = '\0';
					}
				}
				sprintf(LogTmp,"CHAR : %s : \"%s\"\n",script_symbols.get_symbol_name(count1),buffer2);
				free(buffer);
				free(buffer2);
				buffer = NULL;
				buffer2= NULL;

			}else if(script_symbols.get_symbol_type(count1) == TYPE_STR){
				sprintf(LogTmp,"\n");
				output = OFF;
			}else{
				sprintf(LogTmp,"^s\n");
				output = OFF;
			}
			
			if(output == ON){
				printf("%s",LogTmp);
				fputs(LogTmp,fp_dat);
			}
		}
		fclose(fp_dat);
	}
	

	return(ret);
}


//---------------------------------------------------------------------------
//		load()
//---------------------------------------------------------------------------
int nasino_sccom_load(int *sp)
{
	FILE *fp_dat;
	int ret;
//	char *filename;
	char filename[DataLength];
	
	char data_buffer[DicBufferLength];
	char type[5];
	char word[DicBufferLength];
	int symbol_num;							// ϐ̓ԍ

	script_logwrite("-- load --\n");

	ret = OK;
	
//	filename = nasino_script_getstackstring(sp);
	sprintf(filename,"%s%s",DataPath,nasino_script_getstackstring(sp));

	if((fp_dat = fopen(filename,"rt"))==NULL){
		/* nasino.ini don't open!! */
		printf("datafile don't open!!\n");
		ret = NG;
	}else{
		while( fgets(data_buffer,DicBufferLength,fp_dat) != NULL){
			getkeyword_one(type,data_buffer);			// ϐ̌^o
			getsym(data_buffer);						// ؂L폜
			getkeyword_one(word,data_buffer);			// ϐo
			getsym(data_buffer);						// ؂L폜
//			printf("type: %s; word: %s; buffer;%s\n",type,word,data_buffer);
			if(strcmp(type,"INT") == 0){
				symbol_num = script_symbols.make_entory(word,TYPE_INT);
//				printf("symbol_num:%d\n",symbol_num);
				getbufword(word,data_buffer);
//				printf("word:%s\n",word);
				script_symbols.set_symbol_val(symbol_num,atoi(word));
			}else if(strcmp(type,"CHAR") == 0){
				symbol_num = script_symbols.make_entory(word,TYPE_CHAR);
//				printf("symbol_num:%d\n",symbol_num);
				getbufword(word,data_buffer);
//				printf("word:%s\n",word);
				script_symbols.set_symbol_str(symbol_num,word);
			}
		}
		fclose(fp_dat);
	
	}

	return(ret);
}


//---------------------------------------------------------------------------
//		get_initfiledata()
//---------------------------------------------------------------------------
int nasino_sccom_get_initfiledata(int *sp)
{
	int ret;
	char *entry_name;
	char word_tmp[18];
//	char *word;
	int symbol_num;
	
	ret = OK;
	
	printf("nasino_sccom_get_initfiledata\n");

	entry_name = nasino_script_getstackstring(sp);
	
	if(strcmp(entry_name,"talk_interval") == 0){
		printf("ghost_profile.ghosttalkinterval:%d",ghost_profile.ghosttalkinterval);
		itoa(ghost_profile.ghosttalkinterval,word_tmp,10);
	}else{
		word_tmp[0] = '\0';
	}
	printf(":%s:\n",word_tmp);
	symbol_num = script_symbols.make_entory(word_tmp,TYPE_STR);
	nasino_script_setstackval(*sp,symbol_num,TYPE_STR);				// ʂstackɐς
	
	return(ret);
}

